diff --git a/src/config/config.c b/src/config/config.c
index cd7c60cb3..82eaee06e 100644
--- a/src/config/config.c
+++ b/src/config/config.c
@@ -117,12 +117,13 @@ typedef enum {
  *		['_'] = &&l_bare,
  *		['A' ... 'Z'] = &&l_bare, ['a' ... 'z'] = &&l_bare,
  *		['/'] = &&l_bare,
+ *		['%'] = &&l_bare,
  *	};
  */
 static const int8_t gostruct[256] = {A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD,
   A_LOOP, A_LOOP, A_BAD, A_BAD, A_LOOP, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD,
   A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_BAD, A_LOOP, A_BAD, A_QUP, A_BAD,
-  A_BAD, A_BAD, A_BAD, A_BAD, A_UP, A_DOWN, A_BAD, A_BAD, A_NEXT, A_NUMBARE, A_BARE, A_BARE,
+  A_BAD, A_BARE, A_BAD, A_BAD, A_UP, A_DOWN, A_BAD, A_BAD, A_NEXT, A_NUMBARE, A_BARE, A_BARE,
   A_NUMBARE, A_NUMBARE, A_NUMBARE, A_NUMBARE, A_NUMBARE, A_NUMBARE, A_NUMBARE, A_NUMBARE, A_NUMBARE,
   A_NUMBARE, A_VALUE, A_BAD, A_BAD, A_VALUE, A_BAD, A_BAD, A_BAD, A_BARE, A_BARE, A_BARE, A_BARE,
   A_BARE, A_BARE, A_BARE, A_BARE, A_BARE, A_BARE, A_BARE, A_BARE, A_BARE, A_BARE, A_BARE, A_BARE,
@@ -586,6 +587,48 @@ __wt_config_get(
     return (WT_NOTFOUND);
 }
 
+/*
+ * __wt_config_get_api --
+ *     Given a NULL-terminated list of configuration strings, that may be precompiled, find the
+ *     final value for a given key.
+ */
+int
+__wt_config_get_api(WT_SESSION_IMPL *session, const char **cfg_arg, int api, WT_CONFIG_ITEM *key,
+  WT_CONFIG_ITEM *value)
+{
+    WT_CONFIG cparser;
+    WT_CONNECTION_IMPL *conn;
+    WT_DECL_RET;
+    const char **cfg;
+
+    if (cfg_arg[0] == NULL)
+        return (WT_NOTFOUND);
+
+    conn = S2C(session);
+    /*
+     * Search the strings in reverse order, that way the first hit wins and we don't search the base
+     * set until there's no other choice.
+     */
+    for (cfg = cfg_arg; *cfg != NULL; ++cfg)
+        ;
+    do {
+        --cfg;
+
+        if (__wt_is_compiled_config(conn, *cfg)) {
+            if (__wt_compiled_has(conn, *cfg, api))
+                return (__wt_compiled_get(session, api, *cfg, value));
+            continue;
+        }
+
+        __wt_config_init(session, &cparser, *cfg);
+        if ((ret = __config_getraw(&cparser, key, value, true)) == 0)
+            return (0);
+        WT_RET_NOTFOUND_OK(ret);
+    } while (cfg != cfg_arg);
+
+    return (WT_NOTFOUND);
+}
+
 /*
  * __wt_config_gets --
  *     Given a NULL-terminated list of configuration strings, find the final value for a given
@@ -599,6 +642,20 @@ __wt_config_gets(WT_SESSION_IMPL *session, const char **cfg, const char *key, WT
     return (__wt_config_get(session, cfg, &key_item, value));
 }
 
+/*
+ * __wt_config_gets_api --
+ *     Given a NULL-terminated list of configuration strings, find the final value for a given
+ *     string key.
+ */
+int
+__wt_config_gets_api(
+  WT_SESSION_IMPL *session, const char **cfg, int api, const char *key, WT_CONFIG_ITEM *value)
+{
+    WT_CONFIG_ITEM key_item = {key, strlen(key), 0, WT_CONFIG_ITEM_STRING};
+
+    return (__wt_config_get_api(session, cfg, api, &key_item, value));
+}
+
 /*
  * __wt_config_gets_none --
  *     Given a NULL-terminated list of configuration strings, find the final value for a given
@@ -701,6 +758,53 @@ __wt_config_gets_def(
     /* NOTREACHED */
 }
 
+/*
+ * __wt_config_gets_def_api --
+ *     Same as __wt_config_gets_def, but allows for compiled input strings.
+ */
+int
+__wt_config_gets_def_api(WT_SESSION_IMPL *session, const char **cfg, int api, const char *key,
+  int def, WT_CONFIG_ITEM *value)
+{
+    WT_CONFIG_ITEM_STATIC_INIT(false_value);
+    WT_CONNECTION_IMPL *conn;
+    int cfg_len;
+    const char **end;
+
+    *value = false_value;
+    value->val = def;
+
+    if (cfg == NULL)
+        return (0);
+
+    /*
+     * Checking the "length" of the pointer array is a little odd, but it's deliberate. The reason
+     * is because we pass variable length arrays of pointers as the configuration argument, some of
+     * which have only one element and the NULL termination. Static analyzers (like Coverity)
+     * complain if we read from an offset past the end of the array, even if we check there's no
+     * NULL slots before the offset.
+     */
+    for (end = cfg; *end != NULL; ++end)
+        ;
+    cfg_len = (int)(end - cfg);
+    switch (cfg_len) {
+    case 0: /* cfg[0] == NULL */
+    case 1: /* cfg[1] == NULL */
+        return (0);
+    case 2: /* cfg[2] == NULL */
+        conn = S2C(session);
+        if (__wt_is_compiled_config(conn, cfg[1])) {
+            if (__wt_compiled_has(conn, cfg[1], api))
+                WT_RET(__wt_compiled_get(session, api, cfg[1], value));
+        } else
+            WT_RET_NOTFOUND_OK(__wt_config_getones(session, cfg[1], key, value));
+        return (0);
+    default:
+        return (__wt_config_gets_api(session, cfg, api, key, value));
+    }
+    /* NOTREACHED */
+}
+
 /*
  * __wt_config_subgetraw --
  *     Get the value for a given key from a config string in a WT_CONFIG_ITEM. This is useful for
diff --git a/src/config/config_check.c b/src/config/config_check.c
index d07eabcec..466a79fc8 100644
--- a/src/config/config_check.c
+++ b/src/config/config_check.c
@@ -22,7 +22,7 @@ __wt_config_check(
     /*
      * Callers don't check, it's a fast call without a configuration or check array.
      */
-    return (config == NULL || entry->checks == NULL ?
+    return (config == NULL || entry->checks == NULL || __wt_is_compiled_config(S2C(session), config) ?
         0 :
         config_check(session, entry->checks, entry->checks_entries, config, config_len));
 }
diff --git a/src/config/config_def.c b/src/config/config_def.c
index 8894ff6cd..bb88c8d28 100644
--- a/src/config/config_def.c
+++ b/src/config/config_def.c
@@ -3,160 +3,209 @@
 #include "wt_internal.h"
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_close[] = {
-  {"leak_memory", "boolean", NULL, NULL, NULL, 0},
-  {"use_timestamp", "boolean", NULL, NULL, NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"leak_memory", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {"use_timestamp", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 1},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_debug_info[] = {
-  {"cache", "boolean", NULL, NULL, NULL, 0}, {"cursors", "boolean", NULL, NULL, NULL, 0},
-  {"handles", "boolean", NULL, NULL, NULL, 0}, {"log", "boolean", NULL, NULL, NULL, 0},
-  {"sessions", "boolean", NULL, NULL, NULL, 0}, {"txn", "boolean", NULL, NULL, NULL, 0},
-  {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"cache", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {"cursors", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 1},
+  {"handles", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 2},
+  {"log", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 3},
+  {"sessions", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 4},
+  {"txn", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 5},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_load_extension[] = {
-  {"config", "string", NULL, NULL, NULL, 0}, {"early_load", "boolean", NULL, NULL, NULL, 0},
-  {"entry", "string", NULL, NULL, NULL, 0}, {"terminate", "string", NULL, NULL, NULL, 0},
-  {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"config", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 0},
+  {"early_load", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 1},
+  {"entry", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 2},
+  {"terminate", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 3},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_open_session_debug_subconfigs[] = {
-  {"release_evict_page", "boolean", NULL, NULL, NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"release_evict_page", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_open_session[] = {
-  {"cache_cursors", "boolean", NULL, NULL, NULL, 0},
-  {"cache_max_wait_ms", "int", NULL, "min=0", NULL, 0},
-  {"debug", "category", NULL, NULL, confchk_WT_CONNECTION_open_session_debug_subconfigs, 1},
-  {"ignore_cache_size", "boolean", NULL, NULL, NULL, 0},
+  {"cache_cursors", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {"cache_max_wait_ms", "int", NULL, "min=0", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {"debug", "category", NULL, NULL, confchk_WT_CONNECTION_open_session_debug_subconfigs, 1,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 2},
+  {"ignore_cache_size", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 3},
   {"isolation", "string", NULL,
     "choices=[\"read-uncommitted\",\"read-committed\","
     "\"snapshot\"]",
-    NULL, 0},
-  {NULL, NULL, NULL, NULL, NULL, 0}};
+    NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 4},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_query_timestamp[] = {
   {"get", "string", NULL,
     "choices=[\"all_durable\",\"last_checkpoint\",\"oldest\","
     "\"oldest_reader\",\"oldest_timestamp\",\"pinned\",\"recovery\","
     "\"stable\",\"stable_timestamp\"]",
-    NULL, 0},
-  {NULL, NULL, NULL, NULL, NULL, 0}};
+    NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 0},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_block_cache_subconfigs[] = {
-  {"blkcache_eviction_aggression", "int", NULL, "min=1,max=7200", NULL, 0},
-  {"cache_on_checkpoint", "boolean", NULL, NULL, NULL, 0},
-  {"cache_on_writes", "boolean", NULL, NULL, NULL, 0}, {"enabled", "boolean", NULL, NULL, NULL, 0},
-  {"full_target", "int", NULL, "min=30,max=100", NULL, 0},
-  {"hashsize", "int", NULL, "min=512,max=256K", NULL, 0},
-  {"max_percent_overhead", "int", NULL, "min=1,max=500", NULL, 0},
-  {"nvram_path", "string", NULL, NULL, NULL, 0},
-  {"percent_file_in_dram", "int", NULL, "min=0,max=100", NULL, 0},
-  {"size", "int", NULL, "min=0,max=10TB", NULL, 0},
-  {"system_ram", "int", NULL, "min=0,max=1024GB", NULL, 0}, {"type", "string", NULL, NULL, NULL, 0},
-  {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"blkcache_eviction_aggression", "int", NULL, "min=1,max=7200", NULL, 0,
+    WT_CONFIG_COMPILED_TYPE_INT, 3},
+  {"cache_on_checkpoint", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {"cache_on_writes", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 1},
+  {"enabled", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 2},
+  {"full_target", "int", NULL, "min=30,max=100", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 4},
+  {"hashsize", "int", NULL, "min=512,max=256K", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 6},
+  {"max_percent_overhead", "int", NULL, "min=1,max=500", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 7},
+  {"nvram_path", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 8},
+  {"percent_file_in_dram", "int", NULL, "min=0,max=100", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 9},
+  {"size", "int", NULL, "min=0,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 5},
+  {"system_ram", "int", NULL, "min=0,max=1024GB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 10},
+  {"type", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 11},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_checkpoint_subconfigs[] = {
-  {"log_size", "int", NULL, "min=0,max=2GB", NULL, 0},
-  {"wait", "int", NULL, "min=0,max=100000", NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"log_size", "int", NULL, "min=0,max=2GB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {"wait", "int", NULL, "min=0,max=100000", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_reconfigure_compatibility_subconfigs[] = {
-  {"release", "string", NULL, NULL, NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"release", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 0},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_debug_mode_subconfigs[] = {
-  {"checkpoint_retention", "int", NULL, "min=0,max=1024", NULL, 0},
-  {"corruption_abort", "boolean", NULL, NULL, NULL, 0},
-  {"cursor_copy", "boolean", NULL, NULL, NULL, 0}, {"eviction", "boolean", NULL, NULL, NULL, 0},
-  {"log_retention", "int", NULL, "min=0,max=1024", NULL, 0},
-  {"realloc_exact", "boolean", NULL, NULL, NULL, 0},
-  {"rollback_error", "int", NULL, "min=0,max=10M", NULL, 0},
-  {"slow_checkpoint", "boolean", NULL, NULL, NULL, 0},
-  {"table_logging", "boolean", NULL, NULL, NULL, 0},
-  {"update_restore_evict", "boolean", NULL, NULL, NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"checkpoint_retention", "int", NULL, "min=0,max=1024", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {"corruption_abort", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {"cursor_copy", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 2},
+  {"eviction", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 3},
+  {"log_retention", "int", NULL, "min=0,max=1024", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 4},
+  {"realloc_exact", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 5},
+  {"rollback_error", "int", NULL, "min=0,max=10M", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 6},
+  {"slow_checkpoint", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 7},
+  {"table_logging", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 8},
+  {"update_restore_evict", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 9},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_eviction_subconfigs[] = {
-  {"threads_max", "int", NULL, "min=1,max=20", NULL, 0},
-  {"threads_min", "int", NULL, "min=1,max=20", NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"threads_max", "int", NULL, "min=1,max=20", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {"threads_min", "int", NULL, "min=1,max=20", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_file_manager_subconfigs[] = {
-  {"close_handle_minimum", "int", NULL, "min=0", NULL, 0},
-  {"close_idle_time", "int", NULL, "min=0,max=100000", NULL, 0},
-  {"close_scan_interval", "int", NULL, "min=1,max=100000", NULL, 0},
-  {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"close_handle_minimum", "int", NULL, "min=0", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {"close_idle_time", "int", NULL, "min=0,max=100000", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {"close_scan_interval", "int", NULL, "min=1,max=100000", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 2},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_history_store_subconfigs[] = {
-  {"file_max", "int", NULL, "min=0", NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"file_max", "int", NULL, "min=0", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_io_capacity_subconfigs[] = {
-  {"total", "int", NULL, "min=0,max=1TB", NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"total", "int", NULL, "min=0,max=1TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_reconfigure_log_subconfigs[] = {
-  {"archive", "boolean", NULL, NULL, NULL, 0},
-  {"os_cache_dirty_pct", "int", NULL, "min=0,max=100", NULL, 0},
-  {"prealloc", "boolean", NULL, NULL, NULL, 0}, {"remove", "boolean", NULL, NULL, NULL, 0},
-  {"zero_fill", "boolean", NULL, NULL, NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"archive", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {"os_cache_dirty_pct", "int", NULL, "min=0,max=100", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {"prealloc", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 2},
+  {"remove", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 3},
+  {"zero_fill", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 4},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_lsm_manager_subconfigs[] = {
-  {"merge", "boolean", NULL, NULL, NULL, 0},
-  {"worker_thread_max", "int", NULL, "min=3,max=20", NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"merge", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 1},
+  {"worker_thread_max", "int", NULL, "min=3,max=20", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_operation_tracking_subconfigs[] = {
-  {"enabled", "boolean", NULL, NULL, NULL, 0}, {"path", "string", NULL, NULL, NULL, 0},
-  {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"enabled", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {"path", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 1},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_wiredtiger_open_shared_cache_subconfigs[] = {
-  {"chunk", "int", NULL, "min=1MB,max=10TB", NULL, 0}, {"name", "string", NULL, NULL, NULL, 0},
-  {"quota", "int", NULL, NULL, NULL, 0}, {"reserve", "int", NULL, NULL, NULL, 0},
-  {"size", "int", NULL, "min=1MB,max=10TB", NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"chunk", "int", NULL, "min=1MB,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {"name", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 1},
+  {"quota", "int", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 2},
+  {"reserve", "int", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 3},
+  {"size", "int", NULL, "min=1MB,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 4},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_reconfigure_statistics_log_subconfigs[] = {
-  {"json", "boolean", NULL, NULL, NULL, 0}, {"on_close", "boolean", NULL, NULL, NULL, 0},
-  {"sources", "list", NULL, NULL, NULL, 0}, {"timestamp", "string", NULL, NULL, NULL, 0},
-  {"wait", "int", NULL, "min=0,max=100000", NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"json", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 0},
+  {"on_close", "boolean", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_BOOLEAN, 1},
+  {"sources", "list", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_LIST, 2},
+  {"timestamp", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 3},
+  {"wait", "int", NULL, "min=0,max=100000", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 4},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_tiered_manager_subconfigs[] = {
-  {"threads_max", "int", NULL, "min=1,max=20", NULL, 0},
-  {"threads_min", "int", NULL, "min=1,max=20", NULL, 0},
-  {"wait", "int", NULL, "min=0,max=100000", NULL, 0}, {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"threads_max", "int", NULL, "min=1,max=20", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {"threads_min", "int", NULL, "min=1,max=20", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {"wait", "int", NULL, "min=0,max=100000", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 2},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_reconfigure_tiered_storage_subconfigs[] = {
-  {"local_retention", "int", NULL, "min=0,max=10000", NULL, 0},
-  {"object_target_size", "int", NULL, "min=100K,max=10TB", NULL, 0},
-  {NULL, NULL, NULL, NULL, NULL, 0}};
+  {"local_retention", "int", NULL, "min=0,max=10000", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 0},
+  {"object_target_size", "int", NULL, "min=100K,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {NULL, NULL, NULL, NULL, NULL, 0, 0, 0}};
 
 static const WT_CONFIG_CHECK confchk_WT_CONNECTION_reconfigure[] = {
-  {"block_cache", "category", NULL, NULL, confchk_wiredtiger_open_block_cache_subconfigs, 12},
-  {"cache_max_wait_ms", "int", NULL, "min=0", NULL, 0},
-  {"cache_overhead", "int", NULL, "min=0,max=30", NULL, 0},
-  {"cache_size", "int", NULL, "min=1MB,max=10TB", NULL, 0},
-  {"checkpoint", "category", NULL, NULL, confchk_wiredtiger_open_checkpoint_subconfigs, 2},
+  {"block_cache", "category", NULL, NULL, confchk_wiredtiger_open_block_cache_subconfigs, 12,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 0},
+  {"cache_max_wait_ms", "int", NULL, "min=0", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 1},
+  {"cache_overhead", "int", NULL, "min=0,max=30", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 2},
+  {"cache_size", "int", NULL, "min=1MB,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 3},
+  {"checkpoint", "category", NULL, NULL, confchk_wiredtiger_open_checkpoint_subconfigs, 2,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 4},
   {"compatibility", "category", NULL, NULL,
-    confchk_WT_CONNECTION_reconfigure_compatibility_subconfigs, 1},
-  {"debug_mode", "category", NULL, NULL, confchk_wiredtiger_open_debug_mode_subconfigs, 10},
-  {"error_prefix", "string", NULL, NULL, NULL, 0},
-  {"eviction", "category", NULL, NULL, confchk_wiredtiger_open_eviction_subconfigs, 2},
-  {"eviction_checkpoint_target", "int", NULL, "min=0,max=10TB", NULL, 0},
-  {"eviction_dirty_target", "int", NULL, "min=1,max=10TB", NULL, 0},
-  {"eviction_dirty_trigger", "int", NULL, "min=1,max=10TB", NULL, 0},
-  {"eviction_target", "int", NULL, "min=10,max=10TB", NULL, 0},
-  {"eviction_trigger", "int", NULL, "min=10,max=10TB", NULL, 0},
-  {"eviction_updates_target", "int", NULL, "min=0,max=10TB", NULL, 0},
-  {"eviction_updates_trigger", "int", NULL, "min=0,max=10TB", NULL, 0},
-  {"file_manager", "category", NULL, NULL, confchk_wiredtiger_open_file_manager_subconfigs, 3},
-  {"history_store", "category", NULL, NULL, confchk_wiredtiger_open_history_store_subconfigs, 1},
-  {"io_capacity", "category", NULL, NULL, confchk_wiredtiger_open_io_capacity_subconfigs, 1},
-  {"json_output", "list", NULL, "choices=[\"error\",\"message\"]", NULL, 0},
-  {"log", "category", NULL, NULL, confchk_WT_CONNECTION_reconfigure_log_subconfigs, 5},
-  {"lsm_manager", "category", NULL, NULL, confchk_wiredtiger_open_lsm_manager_subconfigs, 2},
-  {"operation_timeout_ms", "int", NULL, "min=0", NULL, 0},
+    confchk_WT_CONNECTION_reconfigure_compatibility_subconfigs, 1, WT_CONFIG_COMPILED_TYPE_CATEGORY,
+    5},
+  {"debug_mode", "category", NULL, NULL, confchk_wiredtiger_open_debug_mode_subconfigs, 10,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 6},
+  {"error_prefix", "string", NULL, NULL, NULL, 0, WT_CONFIG_COMPILED_TYPE_STRING, 7},
+  {"eviction", "category", NULL, NULL, confchk_wiredtiger_open_eviction_subconfigs, 2,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 8},
+  {"eviction_checkpoint_target", "int", NULL, "min=0,max=10TB", NULL, 0,
+    WT_CONFIG_COMPILED_TYPE_INT, 9},
+  {"eviction_dirty_target", "int", NULL, "min=1,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT,
+    10},
+  {"eviction_dirty_trigger", "int", NULL, "min=1,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT,
+    11},
+  {"eviction_target", "int", NULL, "min=10,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 12},
+  {"eviction_trigger", "int", NULL, "min=10,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 13},
+  {"eviction_updates_target", "int", NULL, "min=0,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT,
+    14},
+  {"eviction_updates_trigger", "int", NULL, "min=0,max=10TB", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT,
+    15},
+  {"file_manager", "category", NULL, NULL, confchk_wiredtiger_open_file_manager_subconfigs, 3,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 16},
+  {"history_store", "category", NULL, NULL, confchk_wiredtiger_open_history_store_subconfigs, 1,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 17},
+  {"io_capacity", "category", NULL, NULL, confchk_wiredtiger_open_io_capacity_subconfigs, 1,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 18},
+  {"json_output", "list", NULL, "choices=[\"error\",\"message\"]", NULL, 0,
+    WT_CONFIG_COMPILED_TYPE_LIST, 19},
+  {"log", "category", NULL, NULL, confchk_WT_CONNECTION_reconfigure_log_subconfigs, 5,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 20},
+  {"lsm_manager", "category", NULL, NULL, confchk_wiredtiger_open_lsm_manager_subconfigs, 2,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 21},
+  {"operation_timeout_ms", "int", NULL, "min=0", NULL, 0, WT_CONFIG_COMPILED_TYPE_INT, 22},
   {"operation_tracking", "category", NULL, NULL,
-    confchk_wiredtiger_open_operation_tracking_subconfigs, 2},
-  {"shared_cache", "category", NULL, NULL, confchk_wiredtiger_open_shared_cache_subconfigs, 5},
+    confchk_wiredtiger_open_operation_tracking_subconfigs, 2, WT_CONFIG_COMPILED_TYPE_CATEGORY, 23},
+  {"shared_cache", "category", NULL, NULL, confchk_wiredtiger_open_shared_cache_subconfigs, 5,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 24},
   {"statistics", "list", NULL,
     "choices=[\"all\",\"cache_walk\",\"fast\",\"none\","
     "\"clear\",\"tree_walk\"]",
-    NULL, 0},
+    NULL, 0, WT_CONFIG_COMPILED_TYPE_LIST, 25},
   {"statistics_log", "category", NULL, NULL,
-    confchk_WT_CONNECTION_reconfigure_statistics_log_subconfigs, 5},
-  {"tiered_manager", "category", NULL, NULL, confchk_tiered_manager_subconfigs, 3},
+    confchk_WT_CONNECTION_reconfigure_statistics_log_subconfigs, 5,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 26},
+  {"tiered_manager", "category", NULL, NULL, confchk_tiered_manager_subconfigs, 3,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 27},
   {"tiered_storage", "category", NULL, NULL,
-    confchk_WT_CONNECTION_reconfigure_tiered_storage_subconfigs, 2},
+    confchk_WT_CONNECTION_reconfigure_tiered_storage_subconfigs, 2,
+    WT_CONFIG_COMPILED_TYPE_CATEGORY, 28},
   {"timing_stress_for_test", "list", NULL,
     "choices=[\"aggressive_sweep\",\"backup_rename\","
     "\"checkpoint_reserved_txnid_delay\",\"checkpoint_slow\","
@@ -165,7 +214,7 @@ static const WT_CONFIG_CHECK confchk_WT_CONNECTION_reconfigure[] = {
     "\"history_store_sweep_race\",\"prepare_checkpoint_delay\","
     "\"split_1\",\"split_2\",\"split_3\",\"split_4\",\"split_5\","
     "\"split_6\",\"split_7\",\"tiered_flush_finish\"]",
-    NULL, 0},
+    NULL, 0, WT_CONFIG_COMPILED_TYPE_LIST, 29},
   {"verbose", "list", NULL,
     "choices=[\"api\",\"backup\",\"block\",\"block_cache\","
     "\"checkpoint\",\"checkpoint_cleanup\",\"checkpoint_progress\","
